Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1055)
@@ -6813,5 +6974,5 @@
         }
         if(nSP)
-		      {
+        {
           nL=nSP;
           sPDG=3222;
@@ -6819,5 +6980,5 @@
         }
         else
-		      {
+        {
           nL=nSM;
           sPDG=3112;
@@ -6831,5 +6992,5 @@
       G4double rlM=G4QNucleus(rlPDG).GetMZNS();// Mass of the new residualNonstrangeNucleus
       if(!nSP&&!nSM&&nL==1&&reM>rlM+mSigZ&&G4UniformRand()>.5) // Sigma0 @@ AddToHadroniz.?
-	     {
+      {
         sPDG=3212;
         MLa=mSigZ;
@@ -6840,5 +7001,5 @@
       // @@ Take into account that there can be Iso-Hypernucleus (Add PI+,R & Pi-,R decays)
       if(rlPDG==90000000)                      // Multy Hyperon (HyperNuc of only hyperons)
-	     {
+      {
         if(nL>1) r4M=r4M/nL;                   // split the 4-mom for the MultyLambda
         for(G4int il=0; il<nL; il++)           // loop over Lambdas
@@ -6848,11 +7009,11 @@
         }
       }
-	     else if(reM>rlM+MLa-eps)                  // Lambda(or Sigma) can be split
-	     {
+      else if(reM>rlM+MLa-eps)                  // Lambda(or Sigma) can be split
+      {
         G4LorentzVector n4M(0.,0.,0.,rlM);
         G4LorentzVector h4M(0.,0.,0.,MLa);
         G4double sum=rlM+MLa;
         if(fabs(reM-sum)<eps)
-	       {
+        {
           n4M=r4M*(rlM/sum);
           h4M=r4M*(MLa/sum);
@@ -6869,5 +7030,5 @@
         curHadr->SetQPDG(G4QPDGCode(rlPDG));   // converted hypernucleus
         if(rlPDG==90000002)                    // Additional action with curHadr change
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;
           curHadr->Set4Momentum(newLV);
@@ -6877,5 +7038,5 @@
         }
         else if(rlPDG==90002000)               // Additional action with curHadr change
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;
           curHadr->Set4Momentum(newLV);
@@ -6895,6 +7056,6 @@
         }
       }
-	     else if(reM>rnM+mPi0-eps&&!nSP&&!nSM)    // Lambda->N only if Sigmas are absent
-	     {
+      else if(reM>rnM+mPi0-eps&&!nSP&&!nSM)    // Lambda->N only if Sigmas are absent
+      {
         G4int nPi=static_cast<G4int>((reM-rnM)/mPi0);
         if (nPi>nL) nPi=nL;
@@ -6904,5 +7065,5 @@
         G4double sum=rnM+npiM;
         if(fabs(reM-sum)<eps)
-	       {
+        {
           n4M=r4M*(rnM/sum);
           h4M=r4M*(npiM/sum);
@@ -6926,5 +7087,5 @@
         }
         if(rnPDG==90000002)                    // Additional action with curHadr change
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;
           curHadr->Set4Momentum(newLV);
@@ -6935,5 +7096,5 @@
         }
         else if(rnPDG==90002000)               // Additional action with curHadr change
-	       {
+        {
           G4LorentzVector newLV=n4M/2.;
           curHadr->Set4Momentum(newLV);
@@ -6945,18 +7106,56 @@
         // @@ Add multybaryon decays if necessary
       }
-      else // If this Excepton shows up (lowProbable appearance) => include gamma decay
-	     {
+      else if(reM>rnM-eps)    // Decay in nonstange and gamma
+      {
+        G4LorentzVector n4M(0.,0.,0.,rnM);
+        G4LorentzVector h4M(0.,0.,0.,0.);
+        G4double sum=rnM;
+        if(fabs(reM-sum)<eps) n4M=r4M;
+        else if(reM<sum || !G4QHadron(r4M).DecayIn2(n4M,h4M))
+        {
+          G4cerr<<"***G4QE::FSI:Hypern, M="<<reM<<"<A+n*Pi0="<<sum<<",d="<<sum-reM<<G4endl;
+          throw G4QException("***G4QEnvironment::FSInter: Hypernuclear gamma decay error");
+        }
+        curHadr->Set4Momentum(n4M);
+        curHadr->SetQPDG(G4QPDGCode(rnPDG));   // converted hypernucleus
+#ifdef fdebug
+        G4cout<<"*G4QE::FSI:HypNg "<<r4M<<"->A="<<rnPDG<<n4M<<",gamma="<<h4M<<G4endl;
+#endif
+        G4QHadron* theGamma = new G4QHadron(22,h4M);// Make a New Hadr for the gamma
+        theQHadrons.push_back(theGamma);      // (del.eq.- user is responsible for del)
+        if(rnPDG==90000002)                   // Additional action with curHadr change
+        {
+          G4LorentzVector newLV=n4M/2.;
+          curHadr->Set4Momentum(newLV);
+          curHadr->SetQPDG(G4QPDGCode(90000001));
+          G4QHadron* secHadr = new G4QHadron(curHadr);
+          theQHadrons.push_back(secHadr);     // (del.eq.- user is responsible for del)
+          //theFragments->push_back(secHadr);   // (del.eq.- user is responsible for del)
+        }
+        else if(rnPDG==90002000)              // Additional action with curHadr change
+        {
+          G4LorentzVector newLV=n4M/2.;
+          curHadr->Set4Momentum(newLV);
+          curHadr->SetQPDG(G4QPDGCode(90001000));
+          G4QHadron* secHadr = new G4QHadron(curHadr);
+          theQHadrons.push_back(secHadr);    // (del.eq.- user is responsible for del)
+          //theFragments->push_back(secHadr);    // (del.eq.- user is responsible for del)
+        }
+        // @@ Add multybaryon decays if necessary
+      }
+      else // If this Error shows up (lowProbable appearance) => now it is left as is
+      {
         G4double d=rlM+MLa-reM;
-		G4cerr<<"G4QE::FSI:R="<<rlM<<",S+="<<nSP<<",S-="<<nSM<<",L="<<nL<<",d="<<d<<G4endl;
+        G4cerr<<"G4QE::FSI:R="<<rlM<<",S+="<<nSP<<",S-="<<nSM<<",L="<<nL<<",d="<<d<<G4endl;
         d=rnM+mPi0-reM;
-		G4cerr<<"***G4QE::FSI: HypN="<<hPDG<<", M="<<reM<<"<"<<rnM+mPi0<<",d="<<d<<G4endl;
-        throw G4QException("G4QEnvironment::FSInteract: Hypernuclear conversion");
+        G4cerr<<"***G4QE::FSI: HypN="<<hPDG<<", M="<<reM<<"<"<<rnM+mPi0<<",d="<<d<<G4endl;
+        //throw G4QException("G4QEnvironment::FSInteract: Hypernuclear conversion");
       }
     }
     //unsigned nHd=theQHadrons.size()-1;
     //if(hd==nHd && !fOK)
-	//{
+    //{
     //  G4cout<<"---Warning---G4QE::FSI: The Last #"<<hd<<" hadron must be filled"<<G4endl;
-	//  fOK=true;
+    //  fOK=true;
     //  curHadr = new G4QHadron(theQHadrons[hd]);
     //}
@@ -6997,5 +7196,5 @@
         curHadr->SetQPDG(G4QPDGCode(bPDG)); // Substitute Multibaryon by a baryon
         for (G4int ib=1; ib<brn; ib++)
-		      {
+        {
           G4QHadron* bH = new G4QHadron(bPDG, sp4m);
          theFragments->push_back(bH);     //(del eq. - user is responsible for deleting)
@@ -7163,9 +7362,9 @@
   {
     if(!theLC)                  // Neutron like: n+gam, n+Pi0, p+Pi- are possible
-				{
+    {
       if(qM<mNPi0)              // Only n+gamma decay is possible
-						{
+      {
         if(fabs(qM-mNeut)<eps)
-								{
+        {
 #ifdef pdebug
           G4cout<<"G4QEnv::DecayBaryon: Fill Neutron AsIs"<<G4endl;
@@ -7180,5 +7379,5 @@
       }
       else if(qM>mPPi)          // Both n+pi0 (p=2/3) & p+Pi- (p=1/3) are possible
-						{
+      {
         if(G4UniformRand()>.333333333) // Clebsh value for the Isobar decay
         {
@@ -7192,5 +7391,5 @@
         }
       }
-						else                      // Only n+Pi0 decay is possible
+      else                      // Only n+Pi0 decay is possible
       {
         fQPDG=nQPDG;            // Baryon is neutron
@@ -7199,9 +7398,9 @@
     }
     else if(theLC==1)           // Proton like: p+gam, p+Pi0, n+Pi+ are possible
-				{
+    {
       if(qM<mPPi0)              // Only p+gamma decay is possible
-						{
+      {
         if(fabs(qM-mProt)<eps)
-								{
+        {
 #ifdef pdebug
           G4cout<<"G4QEnv::DecayBaryon: Fill Proton AsIs"<<G4endl;
@@ -7214,5 +7413,5 @@
       }
       else if(qM>mNPi)          // Both p+pi0 (p=2/3) & n+Pi+ (p=1/3) are possible
-						{
+      {
         if(G4UniformRand()<.333333333) // Clebsh value for the Isobar decay
         {
@@ -7227,12 +7426,12 @@
     }
     else if(theLC==2)           // Delta++ like: only p+PiP is possible
-				{
+    {
       if(qM>mPPi)               // Only p+gamma decay is possible
-						{
+      {
         sQPDG=pipQPDG;          // Meson is Pi+ (baryon is proton)
         sMass=mPi;
       }
       else                      // @@ Can be aReason to search for anError in Fragmentation
-						{
+      {
 #ifdef pdebug
         G4cout<<"-Warning-G4QE::DecBary:*AsIs* DEL++ M="<<qM<<"<"<<mPPi<<G4endl;
@@ -7243,7 +7442,7 @@
     }
     else if(theLC==-1)          // Delta- like: only n+PiM is possible
-				{
+    {
       if(qM+eps>mNPi)           // Only p+gamma decay is possible
-						{
+      {
         fQPDG=nQPDG;            // Baryon is neutron
         fMass=mNeut;
@@ -7252,5 +7451,5 @@
       }
       else                      // @@ Can be aReason to search for anError in Fragmentation
-						{
+      {
 #ifdef pdebug
         G4cout<<"-Warning-G4QE::DecBary:*AsIs* DEL++ M="<<qM<<"<"<<mNPi<<G4endl;
@@ -7272,9 +7471,9 @@
   {
     if(!theLC)                  // -->> Lambda/Sz: L+g,L+Pi0,Sz+Pi0,Sm+Pip,Sp+Pim,p+Km,n+Kz
-				{
+    {
       if(qM<mLPi0)              // Only Lambda+gamma decay is possible
-						{
+      {
         if(fabs(qM-mLamb)<eps)
-								{
+        {
 #ifdef pdebug
           G4cout<<"G4QEnv::DecayBaryon: Fill Lambda AsIs"<<G4endl;
@@ -7289,10 +7488,10 @@
       }
       else if(qM<mSzPi0)        // Only Lambda+Pi0 is possible
-						{
+      {
         fQPDG=lQPDG;            // Baryon is Lambda
         fMass=mLamb;
       }
       else if(qM<mSpPi)         // Both Lambda+Pi0 & Sigma0+Pi0 are possible
-						{
+      {
         if(G4UniformRand()>.6)  // @@ Relative probability (take into account Phase Space)
         {
@@ -7307,5 +7506,5 @@
       }
       else if(qM<mSmPi)         // Lambda+Pi0, Sigma0+Pi0, & SigmaP+PiM are possible
-						{
+      {
         G4double ra=G4UniformRand();
         if(ra<.4)               // @@ Rel. probab. (take into account Phase Space)
@@ -7328,5 +7527,5 @@
       }
       else if(qM<mPK)           // Lambda+Pi0, Sig0+Pi0, SigP+PiM, SigM+PiP are possible
-						{
+      {
         G4double ra=G4UniformRand();
         if(ra<.35)              // @@ Rel. probab. (take into account Phase Space)
@@ -7356,5 +7555,5 @@
       }
       else if(qM<mNKZ)          // Lambda+Pi0, Sig0+Pi0, SigP+PiM, SigM+PiP are possible
-						{
+      {
         G4double ra=G4UniformRand();
         if(ra<.3)               // @@ Rel. probab. (take into account Phase Space)
@@ -7390,5 +7589,5 @@
         }
       }
-						else                      // Only n+Pi0 decay is possible
+      else                      // Only n+Pi0 decay is possible
       {
         G4double ra=G4UniformRand();
@@ -7434,9 +7633,9 @@
     }
     else if(theLC==1)           // SigmaP: SigP+gam,SigP+Pi0,Sp+PiP,L+Pi0,p+K0 are possible
-				{
+    {
       if(qM<mLPi)               // Only SigmaPlus+gamma decay is possible
-						{
+      {
         if(fabs(qM-mSigP)<eps)
-								{
+        {
 #ifdef pdebug
           G4cout<<"G4QEnv::DecayBaryon: Fill SigmaPlus AsIs"<<G4endl;
@@ -7451,5 +7650,5 @@
       }
       else if(qM<mSpPi0)        // Only Lambda+PiP is possible
-						{
+      {
         fQPDG=lQPDG;            // Baryon is Lambda
         fMass=mLamb;
@@ -7458,5 +7657,5 @@
       }
       else if(qM<mSzPi)         // Both Lambda+PiP & Sigma0+Pi0 are possible
-						{
+      {
         if(G4UniformRand()<.6)  // @@ Relative probability (take into account Phase Space)
         {
@@ -7473,5 +7672,5 @@
       }
       else if(qM<mPKZ)          // Lambda+PiP, SigmaP+Pi0, & Sigma0+PiP are possible
-						{
+      {
         G4double ra=G4UniformRand();
         if(ra<.4)               // @@ Rel. probab. (take into account Phase Space)
@@ -7496,5 +7695,5 @@
       }
       else                      // Lambda+PiP, SigmaP+Pi0, Sigma0+PiP, p+K0 are possible
-						{
+      {
         G4double ra=G4UniformRand();
         if(ra<.35)              // @@ Rel. probab. (take into account Phase Space)
@@ -7527,9 +7726,9 @@
     }
     else if(theLC==-1)          // SigmaM: SigM+gam,SigM+Pi0,S0+PiM,L+Pi-,n+KM are possible
-				{
+    {
       if(qM<mLPi)               // Only SigmaMinus + gamma decay is possible
-						{
+      {
         if(fabs(qM-mSigM)<eps)
-								{
+        {
 #ifdef pdebug
           G4cout<<"G4QEnv::DecayBaryon: Fill SigmaMinus AsIs"<<G4endl;
@@ -7544,5 +7743,5 @@
       }
       else if(qM<mSzPi)         // Only Lambda+PiM is possible
-						{
+      {
         fQPDG=lQPDG;            // Baryon is Lambda
         fMass=mLamb;
@@ -7551,5 +7750,5 @@
       }
       else if(qM<mSzPi)         // Both Lambda+PiM & Sigma0+PiM are possible
-						{
+      {
         if(G4UniformRand()<.6)  // @@ Relative probability (take into account Phase Space)
         {
@@ -7568,5 +7767,5 @@
       }
       else if(qM<mPKZ)          // Lambda+PiM, Sigma0+PiM, & SigmaM+Pi0 are possible
-						{
+      {
         G4double ra=G4UniformRand();
         if(ra<.4)               // @@ Rel. probab. (take into account Phase Space)
@@ -7591,5 +7790,5 @@
       }
       else                      // Lambda+PiM, Sig0+PiM, SigM+Pi0, n+KM are possible
-						{
+      {
         G4double ra=G4UniformRand();
         if(ra<.35)              // @@ Rel. probab. (take into account Phase Space)
@@ -7634,5 +7833,5 @@
   {
 #ifdef pdebug
-    G4cout<<"---Warning---G4QE::DecBary:*AsIso* UnknBaryon(AntiS) QC="<<qH->GetQC()<<G4endl;
+    G4cout<<"---Warning---G4QE::DecBary:*AsIso*UnknBaryon(AntiS),QC="<<qH->GetQC()<<G4endl;
 #endif
     theQHadrons.push_back(qH);                 // Fill AsIs (delete equivalent)
@@ -7643,5 +7842,5 @@
   G4double sum=fMass+sMass;
   if(fabs(qM-sum)<eps)
-	 {
+  {
     f4Mom=q4M*(fMass/sum);
     s4Mom=q4M*(sMass/sum);
@@ -7656,5 +7855,5 @@
     {
       G4Quasmon* quasH = new G4Quasmon(qH->GetQC(),qH->Get4Momentum());
-	     if(!CheckGroundState(quasH,true)) theQHadrons.push_back(qH); // Cor or fill asItIs
+      if(!CheckGroundState(quasH,true)) theQHadrons.push_back(qH); // Cor or fill asItIs
       else delete qH;  
       delete quasH;
@@ -7679,4 +7878,100 @@
   theQHadrons.push_back(H2);                  // Fill "H2" (delete equivalent)
 } // End of DecayBaryon
+
+//Decay of the Antistrange Nucleus in nucleus & K+/antiK0 (at present only S=-1)
+void G4QEnvironment::DecayAntistrange(G4QHadron* qH)
+{//  ===============================================
+  static const G4QPDGCode kpQPDG(321);          // QPDG for Antistrange positive kaon
+  static const G4QPDGCode kzQPDG(311);          // QPDG for Antistrange neutral anti-kaon
+  static const G4double mK =G4QPDGCode(321).GetMass(); // Mass of antistrange positive Kaon
+  static const G4double mK0=G4QPDGCode(311).GetMass(); // Mass of antistrange neutral aK0
+  static const G4double eps=0.003;
+  //static const G4QNucleus vacuum(90000000);
+  G4int theLS= qH->GetStrangeness();           // Strangness of the Nucleus
+  if(theLS>=0)
+  {
+    G4cerr<<"***G4QEnvironment::DecayAntistrange: S="<<theLS<<", but must be <0"<<G4endl;
+    //#ifdef ppdebug
+    throw G4QException("G4QEnv::DecayAntistrange: Not Antistrange nucleus");
+    //#endif
+    //theQHadrons.push_back(qH);                 // Fill AsIs (delete equivalent)
+    return;
+  }
+  else if(theLS<-1)
+  {
+    G4cout<<"*Warning*G4QEnvironment::DecayAntistrange: S="<<theLS<<",AsIsImprove"<<G4endl;
+    theQHadrons.push_back(qH);                 // Fill AsIs (delete equivalent)
+    return;
+  }
+  G4int theLB= qH->GetBaryonNumber();          // Baryon number of the Nucleus
+  G4int theLC= qH->GetCharge();                // Chsrge of the Nucleus
+  G4int qPDG = qH->GetPDGCode();               // PDG Code of the decaying Nucleus
+  G4int K0PDG= qPDG+999999;                    // Residual nonStrange nucleus for antiK0
+  G4QPDGCode K0QPDG(K0PDG);                    // QPDG of the nuclear residual for antiK0
+  G4double rK0M=K0QPDG.GetMass();              // Mass of the nuclear residual for antiK0
+  G4int KpPDG= qPDG+999000;                    // Residual nonStrange nucleus for K+
+  G4QPDGCode KpQPDG(KpPDG);                    // QPDG of the nuclear residual for K+
+  G4double rKpM=KpQPDG.GetMass();              // Mass of the nuclear residual for K+
+  G4LorentzVector q4M = qH->Get4Momentum();    // Get 4-momentum of the Nucleus
+  G4double         qM = q4M.m();               // Mass of the Nucleus
+#ifdef pdebug
+  G4cout<<"G4QE::DecayAntistrang:S="<<theLS<<",C="<<theLC<<",B="<<theLB<<",M="<<qM<<G4endl;
+#endif
+  // Select a chanel of the decay
+  G4QPDGCode     fQPDG = kzQPDG;               // Prototype for Kaon (anti-K0)
+  G4double       fMass= mK0;
+  G4QPDGCode     sQPDG = K0QPDG;               // Prototype for residual nucleus to Kaon
+  G4double       sMass= rK0M;
+  if(mK0+rK0M>qM)                              // Can not be K0
+  {
+    if(mK+rKpM>qM)                             // Can not be K+ too
+    {
+      G4cout<<"*Warning*G4QEnvironment::DecayAntistrange: Too low mass, keep AsIs"<<G4endl;
+      theQHadrons.push_back(qH);               // Fill AsIs (delete equivalent)
+      return;
+    }
+    else                                       // Switch to K+
+    {
+      fQPDG = kpQPDG;                          // Positive Kaon
+      fMass= mK;
+      sQPDG = KpQPDG;                          // Residual nucleus to K+
+      sMass= rKpM;
+    }
+  }
+  else if(mK+rKpM<qM && theLC>theLB-theLC)     // Switch to K+ if Z>N
+  {
+    fQPDG = kpQPDG;                            // Positive Kaon
+    fMass= mK;
+    sQPDG = KpQPDG;                            // Residual nucleus to K+
+    sMass= rKpM;
+  }
+  G4LorentzVector f4Mom(0.,0.,0.,fMass);
+  G4LorentzVector s4Mom(0.,0.,0.,sMass);
+  G4double sum=fMass+sMass;
+  if(fabs(qM-sum)<eps)
+  {
+    f4Mom=q4M*(fMass/sum);
+    s4Mom=q4M*(sMass/sum);
+  }
+  else if(qM<sum || !G4QHadron(q4M).DecayIn2(f4Mom, s4Mom))
+  {
+#ifdef pdebug
+    G4cout<<"--Warning--G4QE::DecAntistrange: fPDG="<<fQPDG<<"(M="<<fMass<<")+sPDG="<<sQPDG
+          <<"(M="<<sMass<<") > TotM="<<q4M.m()<<G4endl;
+#endif
+    G4cerr<<"***G4QEnv::DecayAntistrange: M="<<qM<<", sum="<<sum<<G4endl;
+    throw G4QException("G4QEnv::DecayAntistrange: Nucleus DecayIn2 error");
+  }
+#ifdef pdebug
+  G4cout<<"G4QEnv::DecayAntistrange: *Done* f4M="<<f4Mom<<",fPDG="<<fQPDG<<", s4M="<<s4Mom
+        <<",sPDG="<<sQPDG<<G4endl;
+#endif
+  delete qH;
+  //
+  G4QHadron* H1 = new G4QHadron(fQPDG,f4Mom); // Create a Hadron for the 1-st baryon
+  theQHadrons.push_back(H1);                  // Fill "H1" (delete equivalent)
+  G4QHadron* H2 = new G4QHadron(sQPDG,s4Mom); // Create a Hadron for the 2-nd baryon
+  theQHadrons.push_back(H2);                  // Fill "H2" (delete equivalent)
+} // End of DecayAntistrange
 
 // Check that it's possible to decay the TotalResidualNucleus in Quasmon+Environ & correct
@@ -7714,6 +8009,10 @@
 
   if ( resB > 1 && 
-       ( (!resS && ((resC == resB && reTM > resC*mProt) || (!resC && reTM > resB*mNeut) ) ) ||
-          (resS == resB && reTM > resS*mLamb) ) ) // Immediate Split(@@Decay) MultiBaryon
+       ( ( !resS && 
+           ( (resC == resB && reTM > resC*mProt) || (!resC && reTM > resB*mNeut) )
+         ) ||
+         (resS == resB && reTM > resS*mLamb)
+       )
+     ) // Immediate Split(@@Decay) MultiBaryon
   {
 #ifdef chdebug
@@ -7728,5 +8027,5 @@
       reTLV=G4LorentzVector(0.,0.,0.,resQMa);   // GSM of the Quasmon
       if(G4QHadron(toLV).DecayIn2(reTLV,enva4M))
-	     {
+      {
 #ifdef pdebug
         G4cout<<"G4QE::CGS: fill EnvPDG="<<envPDG<<",4M="<<enva4M<<" and continue"<<G4endl;
@@ -7756,5 +8055,5 @@
     resEMa=theEnvironment.GetMZNS();            // GSMass of the Residual Environment
 #ifdef cdebug
-	   G4cout<<"G4QE::CGS:EnvironmentExists,gsM="<<resEMa<<",4M="<<enva4M<<enva4M.m()<<G4endl;
+    G4cout<<"G4QE::CGS:EnvironmentExists,gsM="<<resEMa<<",4M="<<enva4M<<enva4M.m()<<G4endl;
 #endif
     reTQC+=theEnvironment.GetQCZNS();           // Quark content of the Residual Nucleus
@@ -7768,7 +8067,7 @@
     G4int    baryn=valQ.GetBaryonNumber();      // Baryon Number of the Residual vacQuasmon
     if(baryn>1)                                 // => "Can split baryon?"
-	   {
+    {
       if(valQ.GetN())                           // ===> "Can split neutron?"
-	     {
+      {
         G4QContent resQC=valQ-neutQC;           // QC of Residual for the Neutron
         G4int    resPDG=resQC.GetSPDGCode();    // PDG of Residual for the Neutron
@@ -7776,7 +8075,7 @@
         G4double resMas=G4QPDGCode(resPDG).GetMass(); // GS Mass of the Residual
         if(resMas+mNeut<resQM) bsCond=true;
-	     }
+      }
       else if(valQ.GetP())                      // ===> "Can split proton?"
-	     {
+      {
         G4QContent resQC=valQ-protQC;           // QC of Residual for the Proton
         G4int    resPDG=resQC.GetSPDGCode();    // PDG of Residual for the Proton
@@ -7784,7 +8083,7 @@
         G4double resMas=G4QPDGCode(resPDG).GetMass(); // GS Mass of the Residual
         if(resMas+mProt<resQM) bsCond=true;
-	     }
+      }
       else if(valQ.GetL())                      // ===> "Can split Lambda?"
-	     {
+      {
         G4QContent resQC=valQ-lambQC;           // QC of Residual for the Lambda
         G4int    resPDG=resQC.GetSPDGCode();    // PDG of Residual for the Lambda
@@ -7792,6 +8091,6 @@
         G4double resMas=G4QPDGCode(resPDG).GetMass(); // GS Mass of the Residual
         if(resMas+mLamb<resQM) bsCond=true;
-	     }
-	   }
+      }
+    }
   }
   G4double resTMa=reTLV.m();                    // CM Mass of the ResidualNucleus (Q+Env)
@@ -7805,5 +8104,5 @@
         <<" then the correction must be done for PDG="<<reTPDG<<G4endl;
 #endif
-  if ( (resTMa < resSMa || (!resEMa && !bsCond) ) && nOfOUT > 0 && corFlag) // *** CORRECTION ***
+  if ( (resTMa < resSMa || (!resEMa && !bsCond) ) && nOfOUT > 0 && corFlag)//**CORRECTION**
   {
     G4QHadron*  theLast = theQHadrons[nOfOUT-1];
@@ -7811,5 +8110,5 @@
     G4int crPDG=theLast->GetPDGCode();
 #ifdef cdebug
-	   G4cout<<"G4QE::CGS: **Correction** lNF="<<cNf<<",lPDG="<<crPDG<<",Q4M="<<reTLV<<G4endl;
+    G4cout<<"G4QE::CGS: **Correction** lNF="<<cNf<<",lPDG="<<crPDG<<",Q4M="<<reTLV<<G4endl;
 #endif
     G4LorentzVector hadr4M = theLast->Get4Momentum();
@@ -7817,5 +8116,5 @@
     G4LorentzVector tmpTLV=reTLV+hadr4M;        // Tot (ResidNucl+LastHadron) 4-Mom
 #ifdef cdebug
-	   G4cout<<"G4QE::CGS:YES, s4M/M="<<tmpTLV<<tmpTLV.m()<<">rSM+hM="<<resSMa+hadrMa<<G4endl;
+    G4cout<<"G4QE::CGS:YES, s4M/M="<<tmpTLV<<tmpTLV.m()<<">rSM+hM="<<resSMa+hadrMa<<G4endl;
 #endif
     G4double tmpTM=tmpTLV.m();
@@ -7848,5 +8147,5 @@
           // Kill environment as it is already included in the decay
           theEnvironment=G4QNucleus(G4QContent(0,0,0,0,0,0), G4LorentzVector(0.,0.,0.,0.));
-		      }
+        }
         else
         {
@@ -7856,5 +8155,5 @@
           return false;
         }
-	     }
+      }
       else                                      // => "Environ is vacuum" case (DecayIn2)
       {
@@ -7873,5 +8172,5 @@
 #endif
           EvaporateResidual(quasH);     // Try to evaporate residual (del.eq.)
-		      }
+        }
         else
         {
@@ -7882,13 +8181,13 @@
           return false;
         }
-	     }
+      }
     }
     else                                        // *** Try Last+Previous CORRECTION ***
     {
 #ifdef cdebug
-	     G4cout<<"G4QEnv::CheckGS: the Last did not help, nH="<<nOfOUT<<G4endl;
+      G4cout<<"G4QEnv::CheckGS: the Last did not help, nH="<<nOfOUT<<G4endl;
 #endif
       if(nOfOUT>1)                              // Cor with Last&Previous can be tryed
-	     {
+      {
         G4QHadron*  thePrev = theQHadrons[nOfOUT-2]; // Get pointer to Prev before Last
         if(thePrev->GetNFragments()||thePrev->GetNFragments()) return false;// Dec H/g
@@ -7900,5 +8199,5 @@
         G4double   tQMa=G4QPDGCode(totPDG).GetMass(); // GS Mass of the Residual Nucleus
 #ifdef cdebug
-	       G4cout<<"G4QE::CGS:T3="<<tmpTLV<<tmpTLV.m()<<">t+h+p="<<tQMa+hadrMa+prevMa<<G4endl;
+        G4cout<<"G4QE::CGS:T3="<<tmpTLV<<tmpTLV.m()<<">t+h+p="<<tQMa+hadrMa+prevMa<<G4endl;
 #endif
         if(tmpTLV.m()>tQMa+hadrMa+prevMa)
@@ -7918,5 +8217,5 @@
             nucH->Set4Momentum(nuc4M);
 #ifdef cdebug
-	           G4cout<<"G4QE::CGS:*SUCCESS**>CHECK, D4M="<<tmpTLV-hadr4M-prev4M-nuc4M<<G4endl;
+            G4cout<<"G4QE::CGS:*SUCCESS**>CHECK, D4M="<<tmpTLV-hadr4M-prev4M-nuc4M<<G4endl;
 #endif
 #ifdef pdebug
@@ -7924,12 +8223,12 @@
 #endif
             EvaporateResidual(nucH);     // Try to evaporate residual (del.eq.)
-	         }
-		      }
+          }
+        }
         else                                  // ===> Try to use any hadron from the output
         {
 #ifdef cdebug
-		        G4cout<<"G4QE::CGS:Prev&Last didn't help,nH="<<nOfOUT<<">2, MQ="<<resQMa<<G4endl;
-#endif
-										G4int nphot=-1;                     // #of photons
+          G4cout<<"G4QE::CGS:Prev&Last didn't help,nH="<<nOfOUT<<">2, MQ="<<resQMa<<G4endl;
+#endif
+          G4int nphot=-1;                     // #of photons
           G4int npip=-1;                      // #of Pi+
           G4int npiz=-1;                      // #of Pi0
@@ -7937,5 +8236,5 @@
           G4double emaz=0.;                   // The maximum energy for pi0 (to sel high E)
           for(G4int id=nOfOUT-1; id>=0; id--) // Search for photons and pi+, and pi-
-  			     {
+          {
             G4QHadron* curHadr = theQHadrons[id];
             G4int hPDG=curHadr->GetPDGCode();
@@ -7944,5 +8243,5 @@
             else if(hPDG==111)
             {
-				          G4double piE=curHadr->Get4Momentum().e();
+              G4double piE=curHadr->Get4Momentum().e();
 #ifdef chdebug
               G4cout<<"G4QE::CheckGroundState:"<<id<<",Epi0="<<piE<<">"<<emaz<<G4endl;
@@ -7957,5 +8256,5 @@
           }
           if(nphot>=0)                 // Photon is found, try to use it to resolve PANIC
-			       {
+          {
             G4QHadron* curHadr = theQHadrons[nphot];      // Pointer to the photon
             G4LorentzVector ch4M=curHadr->Get4Momentum(); // 4-Mom of the Photon
@@ -7963,5 +8262,5 @@
             G4double ttM=tt4M.m();          // Mass of the Phot+ResidQm compaund system
             if(resQMa<ttM)                  // PANIC can be resolved with this Photon
-			         {
+            {
               G4LorentzVector quas4M = G4LorentzVector(0.,0.,0.,resSMa);//GSMass of Quasm
               G4QHadron* rqH = new G4QHadron(reTQC,quas4M); // Prototype of outputResidQ
@@ -7987,5 +8286,5 @@
                                                           G4LorentzVector(0.,0.,0.,0.));
                 return true;
-		            }
+              }
             } // End of the KINEMATIC CHECK FOR THE PHOTON if
           } // End of nphot IF
@@ -7997,5 +8296,5 @@
           if (envPDG == 90000000 && !resS && resB > 1 && 
               ((npip >= 0 && resC == -2) || (npim >= 0 && resC-resB == 2)) )
-	  {
+   {
             G4int npi=npip;               // (Delta-)+(Delta-)+k*n+(pi+)->(k+2)*n+(pi-)
             G4int piPD=-211;
@@ -8023,5 +8322,5 @@
 #endif
             if(suM<ttM)                    // PANIC can be resolved with this Pion
-			         {
+            {
               G4LorentzVector fn4M = G4LorentzVector(0.,0.,0.,suB);//First nucleon(s)
               G4LorentzVector sn4M = G4LorentzVector(0.,0.,0.,nuM);//Second nucleon
@@ -8057,9 +8356,9 @@
 #endif
                 return true;
-		            }
+              }
             } // End of the KINEMATIC CHECK FOR THE PI+/PI- if
           } // End of npip/pin Isonucleus IF
           if(envPDG==90000000&&!resS&&resB>1&&npiz>=0&&(resC<-1||resC-resB>1))
-			       {
+          {
 #ifdef chdebug
             G4cout<<"***G4QE::CGS:Pi0, rPDG="<<resQPDG<<",rC="<<resC<<",rB="<<resB<<G4endl;
@@ -8089,5 +8388,5 @@
 #endif
             if(sum<ttM)                     // PANIC can be resolved with this Pi0
-			         {
+            {
               G4LorentzVector fn4M = G4LorentzVector(0.,0.,0.,suB); // Nucleon(s)
               G4LorentzVector pi4M = G4LorentzVector(0.,0.,0.,suM); // Pion(s)
@@ -8115,16 +8414,16 @@
                 }
 #ifdef chdebug
-					           G4cout<<"G4QE::CGS: nucl="<<nuPD<<fn4M<<resB<<", pion="<<pi4M<<npi<<G4endl;
+                G4cout<<"G4QE::CGS: nucl="<<nuPD<<fn4M<<resB<<", pion="<<pi4M<<npi<<G4endl;
 #endif
 
                 return true;
-		            }
+              }
 #ifdef chdebug
               else G4cout<<"***G4QEnv::CheckGS:DecayIn3:*Pi0* tM="<<ttM<<","<<sum<<G4endl;
 #endif
             } // End of the KINEMATIC CHECK FOR THE PI0 if
-										} // End of npiz Isonucleus IF
+          } // End of npiz Isonucleus IF
 #ifdef cdebug
-		        G4cout<<"G4QE::CGS: Photons can't help nP="<<nphot<<". TryChangeCharge."<<G4endl;
+          G4cout<<"G4QE::CGS: Photons can't help nP="<<nphot<<". TryChangeCharge."<<G4endl;
 #endif
           // > Photons did not help, try to find an appropriate partner to join and decay
@@ -8139,9 +8438,9 @@
           if((!nnPDG||nnPDG==10)&&nnQC.GetBaryonNumber()>0) nnPDG=nnQC.GetZNSPDGCode();
 #ifdef cdebug
-		        G4cout<<"G4QE::CGS: nnPDR="<<nnPDG<<". TryChangeCharge nOUT="<<nOfOUT<<",Iso="
+          G4cout<<"G4QE::CGS: nnPDR="<<nnPDG<<". TryChangeCharge nOUT="<<nOfOUT<<",Iso="
                 <<isoN<<",Nor="<<norN<<",C="<<reTCH<<",B="<<reTBN<<G4endl;
 #endif
           if(isoN)                           // Calculations for the Isonuclear Residual
-			       {
+          {
             if(reTCH<0)                      // "at least one Delta-" isostate (chngPort)
             {
@@ -8150,5 +8449,5 @@
               nnPDG=nnQC.GetSPDGCode();      // Change PDGCode of theResidNormalNucleus
               if(nnPDG==10&&nnQC.GetBaryonNumber()>0) nnPDG=nnQC.GetZNSPDGCode();
-			         }
+            }
             G4QPDGCode nnQPDG(nnPDG);        // Now can even have Q-code !
             if(nnPDG<80000000) nnM=nnQPDG.GetMass(); // Mass for the Fundamental Hadron
@@ -8161,5 +8460,5 @@
             if(force) chx2g=false;
             for(G4int hd=nOfOUT-1; hd>=0; hd--)// Try to use any hadron to resolve PANIC
-  			       {
+            {
               G4QHadron* curHadr = theQHadrons[hd];
               G4int chNF=curHadr->GetNFragments();
@@ -8169,5 +8468,5 @@
               G4LorentzVector ch4M=curHadr->Get4Momentum(); // 4Mom of the Current Hadron
 #ifdef cdebug
-			           G4cout<<"G4QE::CGS:#"<<hd<<",ch="<<chCH<<",b="<<chBN<<",4M="<<ch4M<<G4endl;
+              G4cout<<"G4QE::CGS:#"<<hd<<",ch="<<chCH<<",b="<<chBN<<",4M="<<ch4M<<G4endl;
 #endif
               if(!chNF)
@@ -8177,7 +8476,7 @@
                 G4double ttM=tt4M.m();          // TotalMass of CurHadr+Residual compaund
                 if(isoN)                        // "1 Delta Isonucleus" case
-		              {
+                {
                   if(nnM+mPi+chM<ttM)           // PANIC can be resolved with thisCurHadron
-			               {
+                  {
 #ifdef cdebug
                       G4cout<<"G4QE::CGS:CurH+ResQ+Pion t="<<tt4M<<ttM<<",cM="<<chM<<",rM="
@@ -8209,11 +8508,11 @@
                                                         ,G4LorentzVector(0.,0.,0.,0.));
                       return true;
-		                  }
+                    }
 #ifdef cdebug
-																				else G4cout<<"***G4QE::CGS:DecIn3 CurH+ResQ+Pion dM="<<ttM-chM<<G4endl;
+                    else G4cout<<"***G4QE::CGS:DecIn3 CurH+ResQ+Pion dM="<<ttM-chM<<G4endl;
 #endif
                   }
-                  if ( (reTCH < 0 && chCH > 0) || (reTCH > reTBN && chCH < chBN) ) // Isoexchange can help
-		  {
+                  if ( (reTCH < 0 && chCH > 0) || (reTCH > reTBN && chCH < chBN) ) //IsoEx?
+                  {
                     G4QContent chQC=curHadr->GetQC(); // QuarkCont of the CurrentHadron
                     if(reTCH<0)chQC+=pimQC;           // Add the negativPion QC to CurHadr
